Bug 642858 - Review Request: drupal6-footnotes - Allows to easily create automatically numbered footnote references
Review Request: drupal6-footnotes - Allows to easily create automatically num...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Paul W. Frields
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: InsightReviews
  Show dependency treegraph
 
Reported: 2010-10-13 19:13 EDT by Sven Lankes
Modified: 2011-01-28 14:21 EST (History)
5 users (show)

See Also:
Fixed In Version: drupal6-footnotes-2.5-1.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-28 14:21:38 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
stickster: fedora‑review+
petersen: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Sven Lankes 2010-10-13 19:13:24 EDT
Spec URL: http://sven.lank.es/Fedora/SPECS/drupal-footnotes.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/drupal-footnotes-6.x.2.4-1.fc14.src.rpm
Description: Flexifilter is a module that allows non-admins to create their own, configurable custom filters. It is not limited to simple text replacement or regex replacement; it includes logic such as if() and while() statements, and is easily extendable by other modules.

rpmlint is clean
Comment 1 Sven Lankes 2010-10-13 19:20:08 EDT

*** This bug has been marked as a duplicate of bug 642856 ***
Comment 2 Sven Lankes 2010-10-13 19:22:06 EDT
Please ignore toe "duplicate" note - that was an accident
Comment 3 Sven Lankes 2010-10-18 17:15:48 EDT
new files:

Spec URL: http://sven.lank.es/Fedora/SPECS/drupal6-footnotes.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/drupal6-footnotes-2.4-1.fc14.src.rpm

As discussed on fedora-logistics, the name is changed to include the major drupal version.
Comment 4 Paul W. Frields 2010-11-11 13:56:29 EST
[ FIX ] MUST: rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint drupal6-footnotes-2.4-1.fc14.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint drupal6-footnotes-2.4-1.fc14.noarch.rpm 
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/tiny_mce_popup.js
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/translations/fr.po
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/footnotes_wysiwyg.module
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/footnote.js
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/translations/ja.po
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/langs/en_dlg.js
drupal6-footnotes.noarch: E: wrong-script-end-of-line-encoding /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/langs/en_dlg.js
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/README.txt
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/langs/en.js
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/footnote.htm
drupal6-footnotes.noarch: E: script-without-shebang /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/editor_plugin.js
drupal6-footnotes.noarch: E: wrong-script-end-of-line-encoding /usr/share/drupal/modules/footnotes/footnotes_wysiwyg/tinymce_plugin/editor_plugin.js
1 packages and 0 specfiles checked; 12 errors, 0 warnings.

See below, since these errors (which might otherwise be overlooked?) actually are caused by a separate issue, which is the bundling of TinyMCE.

[ O K ] MUST: The package must be named according to the Package Naming Guidelines.

[ O K ] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

[ O K ] MUST: The package must meet the Packaging Guidelines.

* Note, the Requires that is provided here only works in Fedora, not
  in EPEL.  To make this spec work in EPEL, where we have both a
  "drupal" package and a "drupal6" package, the suggestion on the list
  was to use "drupal6 >= 6.0" here, and have the main Drupal package
  in Fedora add a virtual Provide matching that Require.  That will
  require assistance from user "limb," Jon Ciesla, who maintains the
  base packages for drupal and drupal6.

* To work in EPEL, the definition of %drupaldir in the spec should be
  changed to read:

  %if %{?fedora}
  %define drupaldir %{_datadir}/drupal
  %endif
  %if %{?rhel}
  %define drupaldir %{_datadir}/drupal6
  %endif

[ O K ] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.

[ O K ] MUST: The License field in the package spec file must match the actual license. 

[ O K ] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

[ O K ] MUST: The spec file must be written in American English. 

[ O K ] MUST: The spec file for the package MUST be legible. 

[ O K ] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

[ O K ] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. 

[ N/A ] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. 

[ O K ] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

[ N/A ] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[ N/A ] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 

[ FIX ] MUST: Packages must NOT bundle copies of system libraries.

OK, here's a first for a Drupal module in my experience, which is the bundling of the TinyMCE editor, a LGPL-licensed WYSIWYG editor.  It may be possible to unbundle and not package the WYSIWYG component of Footnotes entirely to avoid this problem.  It's also possible to seek an exception for TinyMCE in this case but my experience is that it's unlikely to be granted.  Alternately, perhaps TinyMCE could be packaged separately from source and then this module patched to use it.

The swiftest alternative is probably to do the following:

%exclude %{drupaldir}/modules/footnotes/footnotes_wysiwyg
%exclude %{drupaldir}/modules/footnotes/tinymce_footnotes

The module seems to install and activate fine without it, though I haven't had a chance to do a content test on it.

[ O K ] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 

[ O K ] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 

[ O K ] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)

[ O K ] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. 

[ O K ] MUST: Each package must consistently use macros. 

[ O K ] MUST: The package must contain code, or permissable content. 

[ O K ] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 

[ O K ] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. 

[ N/A ] MUST: Header files must be in a -devel package. 

[ N/A ] MUST: Static libraries must be in a -static package. 

[ N/A ] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. 

[ N/A ] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 

[ N/A ] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

[ N/A ] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 

[ O K ] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 

[ O K ] MUST: All filenames in rpm packages must be valid UTF-8.
Comment 5 Christoph Wickert 2010-11-21 12:40:18 EST
(In reply to comment #4)
> [ N/A ] MUST: The spec file MUST handle locales properly. This is done by using
> the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

In fact this point does apply here as the package includes
/usr/share/drupal/modules/footnotes/translations/fr.po
/usr/share/drupal/modules/footnotes/translations/ja.po

Better use %find_lang %{name} --all-name.

%define should be %global.
Comment 6 Sven Lankes 2010-11-22 15:19:22 EST
(In reply to comment #5)

>> [ N/A ] MUST: The spec file MUST handle locales properly. This is done by using
>> the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
 
> In fact this point does apply here as the package includes
> /usr/share/drupal/modules/footnotes/translations/fr.po
> /usr/share/drupal/modules/footnotes/translations/ja.po
> Better use %find_lang %{name} --all-name.

Correct me if I'm wrong but find_lang only handles "proper" gettext cases where 
the build process compiles the *.po-Files to binary *.mo files. Here the *.po-Files are used directly and so find_lang cannot be used.

> %define should be %global.

Right. Fixed.
Comment 7 Sven Lankes 2010-11-22 15:30:13 EST
New files:

Spec URL: http://sven.lank.es/Fedora/SPECS/drupal6-footnotes.spec
SRPM URL: http://sven.lank.es/Fedora/SRPM/drupal6-footnotes-2.4-2.fc14.src.rpm

> * Note, the Requires that is provided here only works in Fedora, not
>   in EPEL.  To make this spec work in EPEL, where we have both a
>   "drupal" package and a "drupal6" package, the suggestion on the list
>   was to use "drupal6 >= 6.0" here, and have the main Drupal package
>   in Fedora add a virtual Provide matching that Require.  That will
>   require assistance from user "limb," Jon Ciesla, who maintains the
>   base packages for drupal and drupal6.

I'm going to wait until the drupal rename is through in Fedora before 
building this for F15.

> * To work in EPEL, the definition of %drupaldir in the spec should be
>   changed to read:
>   %if %{?fedora}
>   %define drupaldir %{_datadir}/drupal
>   %endif
>   %if %{?rhel}
>   %define drupaldir %{_datadir}/drupal6
>   %endif

Probably hard to not sound arrogant here but let's concentrate on the review 
for fedora. I promise to do the right thing when bringing the package to EPEL.

I've even removed the buildroot-lines and other cruft that is no longer neccessary for fedora but still needed for EL-5 in the latest update.
 
> [ FIX ] MUST: Packages must NOT bundle copies of system libraries.

Argh. I totally missed this.
 
> The swiftest alternative is probably to do the following:
> %exclude %{drupaldir}/modules/footnotes/footnotes_wysiwyg
> %exclude %{drupaldir}/modules/footnotes/tinymce_footnotes

I've removed this for now. Should anyone ever package tinymce I'll
see if that version can be used for the module.
 
> The module seems to install and activate fine without it, though I haven't had
> a chance to do a content test on it.

I've just tried it - no problems.
Comment 8 Paul W. Frields 2010-12-08 14:31:23 EST
Sorry for the delay Sven -- and thank you for your work on this. OK, your proposal sounds OK and therefore I've marked this as APPROVED.
Comment 9 Paul W. Frields 2010-12-23 10:42:57 EST
Sven, you can now do a git request at any time (as in bug 642857).
Comment 10 Sven Lankes 2011-01-15 15:33:52 EST
New Package SCM Request
=======================
Package Name: drupal6-footnotes
Short Description: Allows to easily create automatically numbered footnote references
Owners: slankes limb
Branches: f14 el5 el6
Comment 11 Jens Petersen 2011-01-18 01:58:26 EST
Git done (by process-git-requests).

No, f13 branch?
Comment 12 Volker Fröhlich 2011-01-18 09:01:25 EST
Please check, if the license is stated as GPLv2+, as all modules hosted in Drupal's CVS must be.
Comment 13 Paul W. Frields 2011-01-18 10:39:55 EST
Volker, thanks for catching that.

Sven, you don't need to rebuild just for a change in the License field, but you should bump the Release and commit a change to the spec file (and note in %changelog) for that purpose before you do builds.  Thanks!
Comment 14 Fedora Update System 2011-01-20 07:07:01 EST
drupal6-footnotes-2.5-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/drupal6-footnotes-2.5-1.fc14
Comment 15 Fedora Update System 2011-01-20 14:56:30 EST
drupal6-footnotes-2.5-1.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update drupal6-footnotes'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/drupal6-footnotes-2.5-1.fc14
Comment 16 Fedora Update System 2011-01-28 14:21:32 EST
drupal6-footnotes-2.5-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.